]> asedeno.scripts.mit.edu Git - git.git/blob - git-am.sh
Disallow working directory commands in a bare repository.
[git.git] / git-am.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005, 2006 Junio C Hamano
4
5 USAGE='[--signoff] [--dotest=<dir>] [--utf8] [--binary] [--3way]
6   [--interactive] [--whitespace=<option>] <mbox>...
7   or, when resuming [--skip | --resolved]'
8 . git-sh-setup
9 set_reflog_action am
10 require_work_tree
11
12 git var GIT_COMMITTER_IDENT >/dev/null || exit
13
14 stop_here () {
15     echo "$1" >"$dotest/next"
16     exit 1
17 }
18
19 stop_here_user_resolve () {
20     if [ -n "$resolvemsg" ]; then
21             echo "$resolvemsg"
22             stop_here $1
23     fi
24     cmdline=$(basename $0)
25     if test '' != "$interactive"
26     then
27         cmdline="$cmdline -i"
28     fi
29     if test '' != "$threeway"
30     then
31         cmdline="$cmdline -3"
32     fi
33     if test '.dotest' != "$dotest"
34     then
35         cmdline="$cmdline -d=$dotest"
36     fi
37     echo "When you have resolved this problem run \"$cmdline --resolved\"."
38     echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
39
40     stop_here $1
41 }
42
43 go_next () {
44         rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
45                 "$dotest/patch" "$dotest/info"
46         echo "$next" >"$dotest/next"
47         this=$next
48 }
49
50 cannot_fallback () {
51         echo "$1"
52         echo "Cannot fall back to three-way merge."
53         exit 1
54 }
55
56 fall_back_3way () {
57     O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
58
59     rm -fr "$dotest"/patch-merge-*
60     mkdir "$dotest/patch-merge-tmp-dir"
61
62     # First see if the patch records the index info that we can use.
63     git-apply -z --index-info "$dotest/patch" \
64         >"$dotest/patch-merge-index-info" &&
65     GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
66     git-update-index -z --index-info <"$dotest/patch-merge-index-info" &&
67     GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
68     git-write-tree >"$dotest/patch-merge-base+" ||
69     cannot_fallback "Patch does not record usable index information."
70
71     echo Using index info to reconstruct a base tree...
72     if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
73         git-apply $binary --cached <"$dotest/patch"
74     then
75         mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
76         mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
77     else
78         cannot_fallback "Did you hand edit your patch?
79 It does not apply to blobs recorded in its index."
80     fi
81
82     test -f "$dotest/patch-merge-index" &&
83     his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git-write-tree) &&
84     orig_tree=$(cat "$dotest/patch-merge-base") &&
85     rm -fr "$dotest"/patch-merge-* || exit 1
86
87     echo Falling back to patching base and 3-way merge...
88
89     # This is not so wrong.  Depending on which base we picked,
90     # orig_tree may be wildly different from ours, but his_tree
91     # has the same set of wildly different changes in parts the
92     # patch did not touch, so recursive ends up canceling them,
93     # saying that we reverted all those changes.
94
95     eval GITHEAD_$his_tree='"$SUBJECT"'
96     export GITHEAD_$his_tree
97     git-merge-recursive $orig_tree -- HEAD $his_tree || {
98             if test -d "$GIT_DIR/rr-cache"
99             then
100                 git-rerere
101             fi
102             echo Failed to merge in the changes.
103             exit 1
104     }
105     unset GITHEAD_$his_tree
106 }
107
108 prec=4
109 dotest=.dotest sign= utf8= keep= skip= interactive= resolved= binary= ws= resolvemsg=
110
111 while case "$#" in 0) break;; esac
112 do
113         case "$1" in
114         -d=*|--d=*|--do=*|--dot=*|--dote=*|--dotes=*|--dotest=*)
115         dotest=`expr "z$1" : 'z-[^=]*=\(.*\)'`; shift ;;
116         -d|--d|--do|--dot|--dote|--dotes|--dotest)
117         case "$#" in 1) usage ;; esac; shift
118         dotest="$1"; shift;;
119
120         -i|--i|--in|--int|--inte|--inter|--intera|--interac|--interact|\
121         --interacti|--interactiv|--interactive)
122         interactive=t; shift ;;
123
124         -b|--b|--bi|--bin|--bina|--binar|--binary)
125         binary=t; shift ;;
126
127         -3|--3|--3w|--3wa|--3way)
128         threeway=t; shift ;;
129         -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
130         sign=t; shift ;;
131         -u|--u|--ut|--utf|--utf8)
132         utf8=t; shift ;;
133         -k|--k|--ke|--kee|--keep)
134         keep=t; shift ;;
135
136         -r|--r|--re|--res|--reso|--resol|--resolv|--resolve|--resolved)
137         resolved=t; shift ;;
138
139         --sk|--ski|--skip)
140         skip=t; shift ;;
141
142         --whitespace=*)
143         ws=$1; shift ;;
144
145         --resolvemsg=*)
146         resolvemsg=$(echo "$1" | sed -e "s/^--resolvemsg=//"); shift ;;
147
148         --)
149         shift; break ;;
150         -*)
151         usage ;;
152         *)
153         break ;;
154         esac
155 done
156
157 # If the dotest directory exists, but we have finished applying all the
158 # patches in them, clear it out.
159 if test -d "$dotest" &&
160    last=$(cat "$dotest/last") &&
161    next=$(cat "$dotest/next") &&
162    test $# != 0 &&
163    test "$next" -gt "$last"
164 then
165    rm -fr "$dotest"
166 fi
167
168 if test -d "$dotest"
169 then
170         case "$#,$skip$resolved" in
171         0,*t*)
172                 # Explicit resume command and we do not have file, so
173                 # we are happy.
174                 : ;;
175         0,)
176                 # No file input but without resume parameters; catch
177                 # user error to feed us a patch from standard input
178                 # when there is already .dotest.  This is somewhat
179                 # unreliable -- stdin could be /dev/null for example
180                 # and the caller did not intend to feed us a patch but
181                 # wanted to continue unattended.
182                 tty -s
183                 ;;
184         *)
185                 false
186                 ;;
187         esac ||
188         die "previous dotest directory $dotest still exists but mbox given."
189         resume=yes
190 else
191         # Make sure we are not given --skip nor --resolved
192         test ",$skip,$resolved," = ,,, ||
193                 die "Resolve operation not in progress, we are not resuming."
194
195         # Start afresh.
196         mkdir -p "$dotest" || exit
197
198         git-mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" ||  {
199                 rm -fr "$dotest"
200                 exit 1
201         }
202
203         # -b, -s, -u, -k and --whitespace flags are kept for the
204         # resuming session after a patch failure.
205         # -3 and -i can and must be given when resuming.
206         echo "$binary" >"$dotest/binary"
207         echo " $ws" >"$dotest/whitespace"
208         echo "$sign" >"$dotest/sign"
209         echo "$utf8" >"$dotest/utf8"
210         echo "$keep" >"$dotest/keep"
211         echo 1 >"$dotest/next"
212 fi
213
214 case "$resolved" in
215 '')
216         files=$(git-diff-index --cached --name-only HEAD) || exit
217         if [ "$files" ]; then
218            echo "Dirty index: cannot apply patches (dirty: $files)" >&2
219            exit 1
220         fi
221 esac
222
223 if test "$(cat "$dotest/binary")" = t
224 then
225         binary=--allow-binary-replacement
226 fi
227 if test "$(cat "$dotest/utf8")" = t
228 then
229         utf8=-u
230 fi
231 if test "$(cat "$dotest/keep")" = t
232 then
233         keep=-k
234 fi
235 ws=`cat "$dotest/whitespace"`
236 if test "$(cat "$dotest/sign")" = t
237 then
238         SIGNOFF=`git-var GIT_COMMITTER_IDENT | sed -e '
239                         s/>.*/>/
240                         s/^/Signed-off-by: /'
241                 `
242 else
243         SIGNOFF=
244 fi
245
246 last=`cat "$dotest/last"`
247 this=`cat "$dotest/next"`
248 if test "$skip" = t
249 then
250         if test -d "$GIT_DIR/rr-cache"
251         then
252                 git-rerere clear
253         fi
254         this=`expr "$this" + 1`
255         resume=
256 fi
257
258 if test "$this" -gt "$last"
259 then
260         echo Nothing to do.
261         rm -fr "$dotest"
262         exit
263 fi
264
265 while test "$this" -le "$last"
266 do
267         msgnum=`printf "%0${prec}d" $this`
268         next=`expr "$this" + 1`
269         test -f "$dotest/$msgnum" || {
270                 resume=
271                 go_next
272                 continue
273         }
274
275         # If we are not resuming, parse and extract the patch information
276         # into separate files:
277         #  - info records the authorship and title
278         #  - msg is the rest of commit log message
279         #  - patch is the patch body.
280         #
281         # When we are resuming, these files are either already prepared
282         # by the user, or the user can tell us to do so by --resolved flag.
283         case "$resume" in
284         '')
285                 git-mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
286                         <"$dotest/$msgnum" >"$dotest/info" ||
287                         stop_here $this
288                 git-stripspace < "$dotest/msg" > "$dotest/msg-clean"
289                 ;;
290         esac
291
292         GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
293         GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
294         GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
295
296         if test -z "$GIT_AUTHOR_EMAIL"
297         then
298                 echo "Patch does not have a valid e-mail address."
299                 stop_here $this
300         fi
301
302         export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
303
304         SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
305         case "$keep_subject" in -k)  SUBJECT="[PATCH] $SUBJECT" ;; esac
306
307         case "$resume" in
308         '')
309             if test '' != "$SIGNOFF"
310             then
311                 LAST_SIGNED_OFF_BY=`
312                     sed -ne '/^Signed-off-by: /p' \
313                     "$dotest/msg-clean" |
314                     tail -n 1
315                 `
316                 ADD_SIGNOFF=`
317                     test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
318                     test '' = "$LAST_SIGNED_OFF_BY" && echo
319                     echo "$SIGNOFF"
320                 }`
321             else
322                 ADD_SIGNOFF=
323             fi
324             {
325                 echo "$SUBJECT"
326                 if test -s "$dotest/msg-clean"
327                 then
328                         echo
329                         cat "$dotest/msg-clean"
330                 fi
331                 if test '' != "$ADD_SIGNOFF"
332                 then
333                         echo "$ADD_SIGNOFF"
334                 fi
335             } >"$dotest/final-commit"
336             ;;
337         *)
338                 case "$resolved$interactive" in
339                 tt)
340                         # This is used only for interactive view option.
341                         git-diff-index -p --cached HEAD >"$dotest/patch"
342                         ;;
343                 esac
344         esac
345
346         resume=
347         if test "$interactive" = t
348         then
349             test -t 0 ||
350             die "cannot be interactive without stdin connected to a terminal."
351             action=again
352             while test "$action" = again
353             do
354                 echo "Commit Body is:"
355                 echo "--------------------------"
356                 cat "$dotest/final-commit"
357                 echo "--------------------------"
358                 printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
359                 read reply
360                 case "$reply" in
361                 [yY]*) action=yes ;;
362                 [aA]*) action=yes interactive= ;;
363                 [nN]*) action=skip ;;
364                 [eE]*) "${VISUAL:-${EDITOR:-vi}}" "$dotest/final-commit"
365                        action=again ;;
366                 [vV]*) action=again
367                        LESS=-S ${PAGER:-less} "$dotest/patch" ;;
368                 *)     action=again ;;
369                 esac
370             done
371         else
372             action=yes
373         fi
374
375         if test $action = skip
376         then
377                 go_next
378                 continue
379         fi
380
381         if test -x "$GIT_DIR"/hooks/applypatch-msg
382         then
383                 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
384                 stop_here $this
385         fi
386
387         echo
388         echo "Applying '$SUBJECT'"
389         echo
390
391         case "$resolved" in
392         '')
393                 git-apply $binary --index $ws "$dotest/patch"
394                 apply_status=$?
395                 ;;
396         t)
397                 # Resolved means the user did all the hard work, and
398                 # we do not have to do any patch application.  Just
399                 # trust what the user has in the index file and the
400                 # working tree.
401                 resolved=
402                 changed="$(git-diff-index --cached --name-only HEAD)"
403                 if test '' = "$changed"
404                 then
405                         echo "No changes - did you forget to use 'git add'?"
406                         stop_here_user_resolve $this
407                 fi
408                 unmerged=$(git-ls-files -u)
409                 if test -n "$unmerged"
410                 then
411                         echo "You still have unmerged paths in your index"
412                         echo "did you forget to use 'git add'?"
413                         stop_here_user_resolve $this
414                 fi
415                 apply_status=0
416                 if test -d "$GIT_DIR/rr-cache"
417                 then
418                         git rerere
419                 fi
420                 ;;
421         esac
422
423         if test $apply_status = 1 && test "$threeway" = t
424         then
425                 if (fall_back_3way)
426                 then
427                     # Applying the patch to an earlier tree and merging the
428                     # result may have produced the same tree as ours.
429                     changed="$(git-diff-index --cached --name-only HEAD)"
430                     if test '' = "$changed"
431                     then
432                             echo No changes -- Patch already applied.
433                             go_next
434                             continue
435                     fi
436                     # clear apply_status -- we have successfully merged.
437                     apply_status=0
438                 fi
439         fi
440         if test $apply_status != 0
441         then
442                 echo Patch failed at $msgnum.
443                 stop_here_user_resolve $this
444         fi
445
446         if test -x "$GIT_DIR"/hooks/pre-applypatch
447         then
448                 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
449         fi
450
451         tree=$(git-write-tree) &&
452         echo Wrote tree $tree &&
453         parent=$(git-rev-parse --verify HEAD) &&
454         commit=$(git-commit-tree $tree -p $parent <"$dotest/final-commit") &&
455         echo Committed: $commit &&
456         git-update-ref -m "$GIT_REFLOG_ACTION: $SUBJECT" HEAD $commit $parent ||
457         stop_here $this
458
459         if test -x "$GIT_DIR"/hooks/post-applypatch
460         then
461                 "$GIT_DIR"/hooks/post-applypatch
462         fi
463
464         go_next
465 done
466
467 rm -fr "$dotest"